using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using PDFXCviewAxLib;
using System.Diagnostics;
using Infragistics.Win.UltraWinToolbars;



namespace PDFViewerActiveTestCS
{

    public partial class Form1 : Form
    {
        private ListViewColumnSorter lvwColumnSorter;

        private bool m_bSkipNotifications = false;

        string[] aPagesLayoutInfoName = { "Single Page", "Continuous", "Facing", "Continuous-Facing" };
        string[] aPagesLayoutInfoValue = { "SinglePage", "Continuous", "Facing", "Continuous-Facing" };

        string[] aPagesZoomValue = { "6400%", "3200%", "2400%", "1600%", "800%", "400%",
            "200%", "100%", "50%", "25%", "12,5%", "8,33%", "Actual Size",
            "Fit Page", "Fit Width" };
        string[] aPagesZoomName = { "6400%", "3200%", "2400%", "1600%", "800%", "400%",
            "200%", "100%", "50%", "25%", "12,5%", "8,33%", "ActualSize",
            "FitPage", "FitWidth" };

        string[] aImageTypeValue = {    "BMP - Windows Bitmap",
                                        "PNG - Portable Network Graphic",
                                        "GIF - Compuserve GIF",
                                        "PBM - Portable Bitmap",
                                        "PGM - Portable Graymap",
                                        "PPM - Portable Pixelmap",
                                        "JBIG2 - Joint Bi-level Image experts Group v2",
                                        "JPEG2000 - JPEG 2000",
                                        "JPEG - Joint Photographic Experts Group",
                                        "WBMP - Wireless Mono Bitmap",
                                        "JNG - JPEG Network Graphic",
                                        "PCX - PC Paintbrush File Format",
                                        "DCX - Multipage PCX",
                                        "TGA - Truevision Targa",
                                        "TIFF - Tag Image File Format"};
        string[] aImageTypeName = { "BMP", "PNG", "GIF", "PBM", "PGM", "PPM", "JBIG2", "JPEG2000", "JPEG", "WBMP", "JNG", "PCX", "DCX", "TGA", "TIFF" };

        string[] aExportModeValue = { "Place all pages to one multi-paged image file", "Place each page range to different multi-paged image file", "Place each page to different image file" };
        string[] aExportModeName = { "AllToOneMultiImage", "EachRangeToOneMultiImage", "EachToOneImage" };
        string[] aResolution = { "72", "96", "100", "150", "300", "400", "600", "1200", "2400"};

        string[] aLangName = { "Use User's Regional Settings", "Use Default Application's Language", "German (Standard)", "French (Standard)", 
                "Romanian", "Spanish (Modern Sort)", "Chinese (Taiwan)", "Chinese (PRC)", "Russian" };
        int[] aLangValue = { 0, -1, 0x0407, 0x040c, 0x0418, 0x0c0a, 0x0404, 0x0804, 0x0419 };


        bool ProcessOnParamChanged = true;
        bool processingDoc = false;
        int g_nActiveDocID;
        bool g_bActiveDocChanged = false;

        public bool StrCompare(string str1, string str2)
        {
            return (String.Compare(str1, str2, true) == 0);
        }

        public Form1()
        {
            InitializeComponent();

            cob_PagesLayout.Items.AddRange(aPagesLayoutInfoName);
            cb_SelectPagesZoom.Items.AddRange(aPagesZoomValue);
            cob_Language.Items.AddRange(aLangName);

            string bsKey = "Enter your valid serial number Here";
            string bsCode = "Enter your valid DevCode Here";
            axCoPDFXCview1.SetDevInfo(bsKey, bsCode);
            FillListView(ref listView_View1, "");

            // Create an instance of a ListView column sorter and assign it 
            // to the ListView control.
            lvwColumnSorter = new ListViewColumnSorter();
            this.listView1.ListViewItemSorter = lvwColumnSorter;
        }

        private bool TryGetProperty(string sName, out object dataOut)
        {
            bool bRes = false;
            try
            {
                axCoPDFXCview1.GetProperty(sName, out dataOut);
                bRes = true;
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                dataOut = null;
            }
            return bRes;
        }

        private bool TryGetProperty(string sName, out object dataOut, int flags)
        {
            bool bRes = false;
            try
            {
                axCoPDFXCview1.GetProperty(sName, out dataOut, flags);
                bRes = true;
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                dataOut = null;
            }
            return bRes;
        }

        private void FillListView(ref ListView lv, string sPrefix)
        {
            m_bSkipNotifications = true;
            object vDataOut;
            string sName = sPrefix + "View.Bars.Count";
            string sObjName, sPropName, sComment;
            if (!TryGetProperty(sName, out vDataOut)) return;
            int iCountBars = (int)vDataOut;
            for (int i = 0; i < iCountBars; i++)
            {
                sObjName = "View.Bars[" + i.ToString() + "].";

                // read name of bar
                sPropName = sPrefix + sObjName + "Name";
                sName = sPropName;
                if (!TryGetProperty(sName, out vDataOut)) return;
                sName = (string)vDataOut;
                ListViewItem lvi = new ListViewItem();
                lvi.Text = sName;

                if (sName == "Tab")
                {
                    sComment = "It can be displayed if MDI mode used and at least one document is opened";
                }
                else if (sName == "Promoting")
                {
                    sComment = "It can be displayed only if there are displayed any other main bar on the top";
                }
                else
                {
                    sComment = "";
                }

                if (sPrefix != "")
                {
                    sPropName = sPrefix + sObjName + "Visible";
                    sName = sPropName;
                    if (!TryGetProperty(sName, out vDataOut)) return;
                    lvi.Checked = ((int)vDataOut == 0) ? false : true;
                }

                // read ID of bar
                sPropName = sPrefix + sObjName + "ID";
                sName = sPropName;
                if (!TryGetProperty(sName, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed)) return;
                sName = (string)vDataOut;
                lvi.SubItems.Add(sName);
                lvi.SubItems.Add("Bar");
                lvi.SubItems.Add(sComment);
                lv.Items.Add(lvi);
            }
            sName = sPrefix + "View.Panes.Count";
            if (!TryGetProperty(sName, out vDataOut)) return;
            int iCountPanes = (int)vDataOut;
            string sID;
            for (int i = 0; i < iCountPanes; i++)
            {
                sObjName = "View.Panes[" + i.ToString() + "].";

                // read ID of bar
                sPropName = sPrefix + sObjName + "ID";
                sName = sPropName;
                if (!TryGetProperty(sName, out vDataOut)) return;
                if ((int)vDataOut < 4)
                    continue;
                sID = vDataOut.ToString();

                // read name of bar
                sPropName = sPrefix + sObjName + "Name";
                sName = sPropName;
                if (!TryGetProperty(sName, out vDataOut)) return;
                sName = (string)vDataOut;
                ListViewItem lvi = new ListViewItem();
                lvi.Text = sName;

                sComment = "";

                if (sPrefix != "")
                {
                    sPropName = sPrefix + sObjName + "Visible";
                    sName = sPropName;
                    if (!TryGetProperty(sName, out vDataOut)) return;
                    lvi.Checked = ((int)vDataOut == 0) ? false : true;
                }

                lvi.SubItems.Add(sID);
                lvi.SubItems.Add("Pane");
                lvi.SubItems.Add(sComment);
                lv.Items.Add(lvi);
            }
            m_bSkipNotifications = false;
        }

        public void ShowErrorMessage(int HResult)
        {
            string str;
            if (HResult != 0)
            {
                try
                {
                    axCoPDFXCview1.GetTextFromResult(HResult, out str);
                    MessageBox.Show(str);
                }
                catch
                {
                    MessageBox.Show("error in GetTextFromResult");
                }
            }
        }

        public string GetTextFromLayout(string iLayout)
        {
            for (int i = 0; i < aPagesLayoutInfoValue.Length; i++)
            {
                if (aPagesLayoutInfoValue[i] == iLayout)
                {
                    return aPagesLayoutInfoName[i];
                }
            }
            return iLayout;
        }

        public string GetTextFromZoom(string iZoom)
        {
            for (int i = 0; i < aPagesZoomName.Length; i++)
            {
                if (aPagesZoomValue[i] == iZoom)
                {
                    return aPagesZoomName[i];
                }
            }
            return iZoom;
        }

        public string GetVersionStr(int nVersion)
        {
            if ((nVersion >= 10) && (nVersion <= 25))
            {
                return (nVersion >> 4).ToString() + "." + (nVersion & 15).ToString();
            }
            else
                return "<Unrecognized>";
        }

        private void OnPropertyChangedDocument(string pName, string pDocPropName, out bool bHandled)
        {
            bHandled = false;
            if (!ProcessOnParamChanged)
            {
                return;
            }

            bool bFullUpdate = (StrCompare(pName, "FullUpdate") || g_bActiveDocChanged);
            bool bByDocument = (pDocPropName != null);

            if (bFullUpdate || StrCompare(pName, "Documents.Count") || StrCompare(pName, "Documents.Active"))
            {
                // Documents Count
                int nCount = 0;
                axCoPDFXCview1.GetDocumentsCount(out nCount);
                tb_ActiveDocs.Minimum = 1;
                tb_ActiveDocs.Maximum = nCount;

                l_totalOpened.Text = "Total Opened: " + nCount.ToString();

                if (nCount > 1)
                {
                    int nIndex = 0;
                    try
                    {
                        axCoPDFXCview1.GetDocumentIndex(g_nActiveDocID, out nIndex);
                    }
                    finally
                    {
                        tb_ActiveDocs.Value = nIndex + 1;
                    }
                }
            }

            int nActiveDocID = g_nActiveDocID;
            bool bHasActiveDoc = (nActiveDocID > 0);

            nud_GoToPage.Enabled = bHasActiveDoc;
            cob_PagesLayout.Enabled = bHasActiveDoc;
            cb_SelectPagesZoom.Enabled = bHasActiveDoc;


            if (!bHasActiveDoc)
            {
                cb_Modified.Enabled = false;
                cb_Modified.Checked = false;
                l_ID.Text = "ID: <None>";
                l_FileName.Text = "File Name: <None>";
                l_Version.Text = "Version: <Unknown>";
                l_PagesCount.Text = "Pages Count: <None>";
                l_CurrentPage.Text = "Current Page: <Unknown>";
                nud_GoToPage.Value = 1;
                t_Title.Text = "";
                t_Author.Text = "";
                t_Subject.Text = "";
                t_Keywords.Text = "";
                t_Producer.Text = "";
                t_Creator.Text = "";
                cob_PagesLayout.Text = "";
                cb_SelectPagesZoom.Text = "";

                return;
            }

            cb_Modified.Enabled = true;

            if (bHandled)
                return;

            if (!bByDocument && !bFullUpdate) // process notifications from document(active) or if need full update
                return;

            if (bFullUpdate || StrCompare(pDocPropName, "ID"))
                l_ID.Text = "ID: " + nActiveDocID;

            object vDataOut = "";
            // Modified
            if (bFullUpdate || StrCompare(pDocPropName, "Modified"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Modified";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut != 0)
                        cb_Modified.Checked = true;
                    else
                        cb_Modified.Checked = false;
                }
                if (!bFullUpdate)
                    return;
            }

            // File Name
            if (bFullUpdate || StrCompare(pDocPropName, "FileName"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "FileName";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    l_FileName.Text = "File Name: " + vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Title
            if (bFullUpdate || StrCompare(pDocPropName, "Title"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Title";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    t_Title.Text = (string)vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Author
            if (bFullUpdate || StrCompare(pDocPropName, "Author"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Author";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    t_Author.Text = (string)vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Subject
            if (bFullUpdate || StrCompare(pDocPropName, "Subject"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Subject";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    t_Subject.Text = (string)vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Keywords
            if (bFullUpdate || StrCompare(pDocPropName, "Keywords"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Keywords";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    t_Keywords.Text = (string)vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Producer
            if (bFullUpdate || StrCompare(pDocPropName, "Producer"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Producer";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    t_Producer.Text = (string)vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Creator
            if (bFullUpdate || StrCompare(pDocPropName, "Creator"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Creator";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    t_Creator.Text = (string)vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Version
            if (bFullUpdate || StrCompare(pDocPropName, "Version"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Version";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    l_Version.Text = "Version: " + GetVersionStr((int)vDataOut);
                }
                if (!bFullUpdate)
                    return;
            }

            // Pages Count 
            if (bFullUpdate || StrCompare(pDocPropName, "Pages.Count"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Pages.Count";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    l_PagesCount.Text = "Pages Count: " + vDataOut;
                    nud_GoToPage.Maximum = (int)vDataOut;
                }
                if (!bFullUpdate)
                    return;
            }

            // Current Page
            if (bFullUpdate || StrCompare(pDocPropName, "Pages.Current"))
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "Pages.Current";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    l_CurrentPage.Text = "Current Page: " + ((int)vDataOut + 1);
                }
                if (!bFullUpdate)
                    return;
            }

            // Pages Layout
            if (bFullUpdate || StrCompare(pDocPropName, "Pages.Layout"))
            {
                {
                    cob_PagesLayout.Text = "";
                    try
                    {
                        object vDataIn = nActiveDocID;
                        string bsVerb = "Pages.Layout";
                        axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                    }
                    finally
                    {
                        cob_PagesLayout.Text = GetTextFromLayout((string)vDataOut);
                    }
                }
                if (!bFullUpdate)
                    return;
            }

            // Pages Zoom
            if (bFullUpdate || StrCompare(pDocPropName, "Pages.Zoom"))
            {
                {
                    cb_SelectPagesZoom.Text = "";
                    try
                    {
                        object vDataIn = nActiveDocID;
                        string bsVerb = "Pages.Zoom";
                        axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                    }
                    finally
                    {
                        cb_SelectPagesZoom.Text = (string)vDataOut;
                    }
                }
                if (!bFullUpdate)
                    return;
            }
            return;
        }

        private void OnPropertyChangedGeneral(string pName)
        {
            bool bFullUpdate = StrCompare(pName, "FullUpdate");
            object vDataOut = "";
            if (bFullUpdate || StrCompare(pName, "General.DocumentInterface"))
            {
                try
                {
                    object vDataIn = "";
                    string bsVerb = "General.DocumentInterface";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut == 1)
                        rb_SDI.Checked = true;
                    else
                        rb_MDI.Checked = true;
                }
                return;
            }
            if (bFullUpdate || StrCompare(pName, "General.AllowAllAccelerators"))
            {
                try
                {
                    object vDataIn = "";
                    string bsVerb = "General.AllowAllAccelerators";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut == 1)
                        cb_EnableAllAccel.Checked = true;
                    else
                        cb_EnableAllAccel.Checked = false;
                }
                return;
            }
            if (bFullUpdate || StrCompare(pName, "General.DenyAllContextMenus"))
            {
                try
                {
                    object vDataIn = "";
                    string bsVerb = "General.DenyAllContextMenus";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut == 1)
                        cb_DenyContext.Checked = true;
                    else
                        cb_DenyContext.Checked = false;
                }
                return;
            }
            if (bFullUpdate || StrCompare(pName, "General.DenyAllExportOperations"))
            {
                try
                {
                    object vDataIn = "";
                    string bsVerb = "General.DenyAllExportOperations";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut == 1)
                        cb_DenyExport.Checked = true;
                    else
                        cb_DenyExport.Checked = false;
                }
                return;
            }
        }

        private void OnPropertyChangedView(string sName)
        {
            string sPropName = sName;
            int iCount;
            object vDataOut;

            if (sName == "Documents.Active")
            {
                try
                {
                    axCoPDFXCview1.GetActiveDocument(out g_nActiveDocID);
                }
                catch (Exception ex)
                {
                    ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                    return;
                }

                listView_View2.Items.Clear();
                //If we are opening a new document or changing active document in MDI mode
                if (g_nActiveDocID >= 0)
                {
                    sPropName = "FileName";
                    try
                    {
                        axCoPDFXCview1.GetDocumentProperty(g_nActiveDocID, sPropName, out vDataOut, 0);
                    }
                    catch (Exception ex)
                    {
                        ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                        return;
                    }
                    t_OpenDocFileName.Text = (string)vDataOut;

                    string sPrefix = "Documents[#" + g_nActiveDocID.ToString() + "].";
                    FillListView(ref listView_View2, sPrefix);
                }
                //If we are closing document
                else
                {
                    t_OpenDocFileName.Text = "";
                }
            }
            else
            {
                bool bVisible;
                int iID = 0;
                int iType = 0;
                int iEaten = 0;
                string sProperName = "";
                string sID = "";
                try
                {
                    axCoPDFXCview1.GetViewObjectFromName(sName, out iType, out iID, out sProperName, out iEaten);
                }
                catch (Exception ex)
                {
                    return;
                }
                if (iID == -1 || sName.Substring(iEaten).CompareTo("Visible") != 0)
                {
                    return;
                }

                if (!TryGetProperty(sName, out vDataOut)) return;
                bVisible = (int)vDataOut == 0 ? false : true;
                sID = iID.ToString();
                string sBuffer;
                iCount = listView_View1.Items.Count;
                int iItem = -1;

                for (int i = 0; i < iCount; i++)
                {
                    sBuffer = listView_View1.Items[i].SubItems[1].Text;
                    if (sBuffer == sID)
                    {
                        listView_View1.Items[i].Checked = bVisible;
                        iItem = i;
                        break;
                    }
                }
                if (iItem == -1)
                {
                    iCount = listView_View2.Items.Count;
                    for (int i = 0; i < iCount; i++)
                    {
                        sBuffer = listView_View2.Items[i].SubItems[1].Text;
                        if (sBuffer == sID)
                        {
                            listView_View2.Items[i].Checked = bVisible;
                            iItem = i;
                            break;
                        }
                    }
                }
            }
        }

        private void OnPropertyChangedPrint(string pName)
        {
            bool bFullUpdate = StrCompare(pName, "FullUpdate");
            int nActiveDocID = g_nActiveDocID;
            bool bHasActiveDoc = (nActiveDocID > 0);
            //
            b_PrintDlg.Enabled = bHasActiveDoc;
            rb_printAll.Enabled = bHasActiveDoc;
            rb_printCurr.Enabled = bHasActiveDoc;
            rb_printExactly.Enabled = bHasActiveDoc;
            t_printExactly.Enabled = bHasActiveDoc;
            cb_printReverse.Enabled = bHasActiveDoc;
            cb_printGrayscale.Enabled = bHasActiveDoc;
            b_Print.Enabled = bHasActiveDoc;
            //
            object vDataOut = "";

            if (bHasActiveDoc)
            {                
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "FileName";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    l_pFileName.Text = vDataOut.ToString();
                }
            }
            else
                l_pFileName.Text = "<None>";

            if (bFullUpdate || StrCompare(pName, "Print.PrinterName"))
            {
                l_PrinterName.Text = "<Default>";
                try
                {
                    string bsVerb = "Print.PrinterName";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if (vDataOut.ToString().Length>0)
                        l_PrinterName.Text = vDataOut.ToString();
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Print.RangeType"))
            {
                try
                {
                    string bsVerb = "Print.RangeType";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                }
                finally
                {
                    string rt = vDataOut.ToString();
                    if (rt == "All")
                        rb_printAll.Checked = true;
                    else
                        if (rt == "Current")
                            rb_printCurr.Checked = true;
                        else
                            if (rt == "Exactly")
                                rb_printExactly.Checked = true;
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Print.RangeText"))
            {
                try
                {
                    string bsVerb = "Print.RangeText";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
               }
               finally
               {
                   t_printExactly.Text = vDataOut.ToString();
               }
               if (!bFullUpdate)
                   return;
            }

            if (bFullUpdate || StrCompare(pName, "Print.RangeReverse"))
            {
                try
                {
                    string bsVerb = "Print.RangeReverse";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut==0)
                        cb_printReverse.Checked = false;
                    else
                        cb_printReverse.Checked = true;
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Print.AsGrayscale"))
            {
                try
                {
                    string bsVerb = "Print.AsGrayscale";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut == 0)
                        cb_printGrayscale.Checked = false;
                    else
                        cb_printGrayscale.Checked = true;
                }
                if (!bFullUpdate)
                    return;
            }
        }

        private void OnPropertyChangedExport(string pName)
        {
            bool bFullUpdate = StrCompare(pName, "FullUpdate");
            int nActiveDocID = g_nActiveDocID;
            bool bHasActiveDoc = (nActiveDocID > 0);
            //
            btn_ShowExportDialog.Enabled = bHasActiveDoc;
            cob_ImageType.Enabled = bHasActiveDoc;
            cob_Resolution.Enabled = bHasActiveDoc;
            cob_ExportMode.Enabled = bHasActiveDoc;
            rb_exportAll.Enabled = bHasActiveDoc;
            rb_exportCurr.Enabled = bHasActiveDoc;
            rb_exportExactly.Enabled = bHasActiveDoc;
            t_exportExactly.Enabled = bHasActiveDoc;
            cb_exportReverse.Enabled = bHasActiveDoc;
            t_exportDestination.Enabled = bHasActiveDoc;
            b_exportBrowse.Enabled = bHasActiveDoc;
            t_exportFileName.Enabled = bHasActiveDoc;
            b_ApplyAndExport.Enabled = bHasActiveDoc;
            radioButton1.Enabled = bHasActiveDoc;
            cb_Transparent.Enabled = bHasActiveDoc;
            cob_DuplexMode.Enabled = bHasActiveDoc;
            //
            object vDataOut = "";
            if (bHasActiveDoc)
            {
                try
                {
                    object vDataIn = nActiveDocID;
                    string bsVerb = "FileName";
                    axCoPDFXCview1.GetDocumentProperty(nActiveDocID, bsVerb, out vDataOut, 0);
                }
                finally
                {
                    l_pFileNameExp.Text = vDataOut.ToString();
                }
            }
            else
                l_pFileNameExp.Text = "<None>";

            if (bFullUpdate || StrCompare(pName, "Export.Image.Resolution"))
            {
                try
                {
                    string bsVerb = "Export.Image.Resolution";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                }
                finally
                {
                    cob_Resolution.Text = "";
                    cob_Resolution.SelectedText = vDataOut.ToString();
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Export.Image.Type"))
            {
                try
                {
                    string bsVerb = "Export.Image.Type";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                }
                finally
                {
                    int i;
                    string aName = vDataOut.ToString();
                    string aValue = aName;
                    for (i = 0; i < aImageTypeName.Length; i++)
                        if (aImageTypeName[i] == aName)
                        {
                            aValue = aImageTypeValue[i];
                            break;
                        }

                    cob_ImageType.Text = "";
                    cob_ImageType.SelectedText = aValue;
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Export.Image.Mode"))
            {
                try
                {
                    string bsVerb = "Export.Image.Mode";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                }
                finally
                {
                    cob_ExportMode.Text = "";
                    int i;
                    string aName = vDataOut.ToString();
                    string aValue = aName;
                    for (i = 0; i < aExportModeName.Length; i++)
                    {
                        if (aExportModeName[i] == aName)
                        {
                            aValue = aExportModeValue[i];
                            break;
                        }
                    }

                    cob_ExportMode.SelectedText = aValue;
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Export.Image.Background"))
            {
                try
                {
                    string bsVerb = "Export.Image.Background";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if (((int)vDataOut & 0xFF000000) == 0)
                        cb_Transparent.Checked = true;
                    else
                        cb_Transparent.Checked = false;
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Export.Image.RangeType"))
            {
                try
                {
                    string bsVerb = "Export.Image.RangeType";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                }
                finally
                {
                    string rt = vDataOut.ToString();
                    if (rt == "All")
                        rb_exportAll.Checked = true;
                    else
                        if (rt == "Current")
                            rb_exportCurr.Checked = true;
                        else
                            if (rt == "Exactly")
                                rb_exportExactly.Checked = true;
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Export.Image.RangeText"))
            {
                try
                {
                    string bsVerb = "Export.Image.RangeText";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    t_exportExactly.Text = vDataOut.ToString();
                }
                if (!bFullUpdate)
                    return;
            }

            if (bFullUpdate || StrCompare(pName, "Export.Image.RangeReverse"))
            {
                try
                {
                    string bsVerb = "Export.Image.RangeReverse";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    if ((int)vDataOut != 0)
                        cb_exportReverse.Checked = true;
                    else
                        cb_exportReverse.Checked = false;
                }
                if (!bFullUpdate)
                    return;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                axCoPDFXCview1.ApplyAllCachedChanges();
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void b_OpenDoc_Click(object sender, EventArgs e)
        {
            int nDocID;
            try
            {
                int nFlags = 0;
                if (cb_OpenWithoutUI.Checked)
                    nFlags = (int)PDFXCviewAxLib.PXCVA_Flags.PXCVA_NoUI;
                axCoPDFXCview1.OpenDocument(t_OpenDocFileName.Text, t_OpenDocPass.Text, out nDocID, nFlags);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void b_OpenDialog_Click(object sender, EventArgs e)
        {
            try
            {
                int nDocID;
                axCoPDFXCview1.OpenDocument(null, null, out nDocID, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

        }

        private void b_CloseActDoc_Click(object sender, EventArgs e)
        {
            if (g_nActiveDocID < 0)
                return;

            try
            {
                axCoPDFXCview1.CloseDocument(g_nActiveDocID, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

        }

        private void b_CloseAllDocs_Click(object sender, EventArgs e)
        {
            try
            {
                axCoPDFXCview1.CloseAllDocuments(0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void b_Browse_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK == openFileDialog1.ShowDialog(this))
            {
                t_OpenDocFileName.Text = openFileDialog1.FileName;
            }
        }

        private void cb_SelectPagesZoom_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nID;
            if (processingDoc)
                return;

            nID = g_nActiveDocID;
            if (nID < 0)
                return;

            int nIndex;
            nIndex = cb_SelectPagesZoom.SelectedIndex;
            if (nIndex < 0)
                return;

            try
            {
                object vDataIn = GetTextFromZoom(cb_SelectPagesZoom.Text);
                string bsVerb = "Pages.Zoom";
                axCoPDFXCview1.SetDocumentProperty(nID, bsVerb, vDataIn, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

            return;
        }

        private void cb_PagesLayout_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (processingDoc)
                return;
            int nID;
            nID = g_nActiveDocID;

            if (nID < 0)
                return;

            int nIndex;
            nIndex = cob_PagesLayout.SelectedIndex;
            if (nIndex < 0)
                return;

            try
            {
                object vDataIn = aPagesLayoutInfoValue[nIndex];
                string bsVerb = "Pages.Layout";
                axCoPDFXCview1.SetDocumentProperty(nID, bsVerb, vDataIn, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

            return;

        }

        private void nud_GoToPage_ValueChanged(object sender, EventArgs e)
        {
            if (processingDoc)
                return;
            int nID;
            try
            {
                axCoPDFXCview1.GetActiveDocument(out nID);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                return;
            }
            if (nID == -1)
                return;

            int nPage = (int)nud_GoToPage.Value - 1;

            string bsVerb = "Pages.Current";
            object vDataIn = nPage;
            try
            {
                axCoPDFXCview1.SetDocumentProperty(g_nActiveDocID, bsVerb, vDataIn, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

            return;

        }

        private void rb_SDI_CheckedChanged(object sender, EventArgs e)
        {
            object vDataIn;
            if (rb_SDI.Checked)
                vDataIn = 1;
            else
                vDataIn = 0;
            string bsVerb = "General.DocumentInterface";
            try
            {
                object vDataOut;
                int cache;
                if (cb_ChacheChanges.Checked)
                    cache = 1;
                else
                    cache = 0;
                axCoPDFXCview1.DoVerb(bsVerb, "SET", vDataIn, out vDataOut, cache);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
            return;
        }

        private void b_JRun_Click(object sender, EventArgs e)
        {
            if (t_Jscript.Text.Length == 0)
                return;
            string bsResult = "";
            try
            {
                axCoPDFXCview1.RunJavaScript(t_Jscript.Text, out bsResult, 0, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
            t_Jresult.Text = bsResult;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            ProcessOnParamChanged = false;
        }

        private void tb_ActiveDocs_ValueChanged(object sender, EventArgs e)
        {
            if (processingDoc)
                return;
            int nIndex = tb_ActiveDocs.Value - 1;
            int nID = 0;
            try
            {
                axCoPDFXCview1.GetDocumentID(nIndex, out nID);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
            if (nID != 0)
                try
                {
                    axCoPDFXCview1.ActivateDocument(nID, 0);
                }
                catch (Exception ex)
                {
                    ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string str;
            object vDataIn;
            str = "General.ApplicationTitle";
            vDataIn = t_AppTitle.Text;
            try
            {
                object vDataOut;
                axCoPDFXCview1.DoVerb(str,"SET", vDataIn, out vDataOut);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void axCoPDFXCview1_OnEvent(object sender, AxPDFXCviewAxLib._IPDFXCviewEvents_OnEventEvent e)
        {
            switch(e.type)
            {
            case (int)PDFXCviewAxLib.PXCVA_EventTypes.PXCVA_OnPropertyChanged:
                {
                    OnPropertyChanged(e.name);
                }
				break;

			// Start adding new code...
//            case (int)PDFXCviewAxLib.PXCVA_EventTypes.PXCVA_OnNamedNotify:
//                {
//                    if (e.name.ToUpper() == "NOTIFICATIONS.CONTEXTMENU")
//                    {
//                        // Deny all Viewer menus so we can display our own menus.
//                        string menuName = InternalDoVerb<string>("Notifications.ContextMenu.MenuName", "get");

//                        if (menuName.ToUpper() == "PAGEPOPUP")
//                        {
//                            axCoPDFXCview1.SetProperty("Notifications.ContextMenu.UserChoice", "Deny");

////							axCoPDFXCview1.ContextMenuStrip.Close();

//                            // Get screen coordinates where the mouse was clicked.  I will show my menu there.
//                            Point mouseClickPoint = new Point();

//                            mouseClickPoint.X = InternalDoVerb<int>("Notifications.ContextMenu.x", "get");
//                            mouseClickPoint.Y = InternalDoVerb<int>("Notifications.ContextMenu.y", "get");

//                            // Create a nice little Windows Generic menu.
//                            ContextMenuStrip menu = new ContextMenuStrip();
//                            for (int i = 0; i < 7; i++)
//                                menu.Items.Add(string.Format("Menu Item {0}", i));

//                            axCoPDFXCview1.ContextMenuStrip = menu;

//                            axCoPDFXCview1.ContextMenuStrip.Show(mouseClickPoint);
//                        }
//                    }
//                    break;
//                }
			}
		}




		[DebuggerStepThrough] private T InternalDoVerb<T>(string objectName, string operationName, object dataIn, PXCVA_Flags flags) { return InternalDoVerb<T>(objectName, operationName, dataIn, (int)flags); }
		[DebuggerStepThrough] private T InternalDoVerb<T>(string objectName, string operationName, object dataIn) { return InternalDoVerb<T>(objectName, operationName, dataIn, 0); }
		[DebuggerStepThrough] private T InternalDoVerb<T>(string objectName, string operationName) { return InternalDoVerb<T>(objectName, operationName, null, 0); }
		private T InternalDoVerb<T>(string objectName, string operationName, object dataIn, int flags)
		{
			object dataOut = null;

			axCoPDFXCview1.DoVerb(objectName, operationName, dataIn, out dataOut, flags);

			// For repo-ing the menu bug, simply force-type the return value.
			if (typeof(T).Name.ToLower() == "object")
				return (T)dataOut;

			return (T) dataOut;
		}















        private void OnPropertyChanged(string pName)
        {
            int nDocID = -1;
            int nNameEaten = 0;
            processingDoc = true;
            if (pName != "FullUpdate")
            {
                bool bChangeActiveDocNotify = StrCompare(pName, "Documents.Active");
                if (bChangeActiveDocNotify)
                {
                    try
                    {
                        axCoPDFXCview1.GetActiveDocument(out nDocID);
                    }
                    catch (Exception) {}

                    if (g_nActiveDocID != nDocID)
                    {
                        g_bActiveDocChanged = true;
                        g_nActiveDocID = nDocID;
                    }
                }
                else
                {
                    try
                    {
                        axCoPDFXCview1.GetDocumentFromName(pName, out nDocID, ref nNameEaten);
                    }
                    catch (Exception) { }

                    if (nDocID > 0) // notify from document
                    {
                        if (nDocID != g_nActiveDocID) // we process all doc-notifications from active document only
                            goto Finish;
                    }                    
                }
            }
            string DocPropName = null;
            if (nNameEaten != 0)
            {
                DocPropName = pName.Substring(nNameEaten, pName.Length - nNameEaten);
            }

            bool bHandled;
            try
            {
                OnPropertyChangedDocument(pName, DocPropName, out bHandled);
                if (bHandled)
                    goto Finish;
                OnPropertyChangedView(pName);
                OnPropertyChangedGeneral(pName);
                OnPropertyChangedPrint(pName);
                OnPropertyChangedExport(pName);
                OnPropertyChangedLanguage(pName);
                if (pName == "FullUpdate")
                    ReloadCommandsList();

            }
            catch (Exception){}
          
            Finish:
            g_bActiveDocChanged = false;
            processingDoc = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            OnPropertyChanged("FullUpdate");
            cob_DuplexMode.SelectedIndex = 0;
        }

        private void b_Print_Click(object sender, EventArgs e)
        {
            int nActiveDocID = g_nActiveDocID;
            if (nActiveDocID < 0)
                return;
            
            int cache;

            if (cb_ChacheChanges.Checked)
                cache = (int)PXCVA_Flags.PXCVA_NoApply;
                else
                    cache = 0;

            try
            {
                string bsVerb = "Print.RangeType";
                object vDataIn = "";
                if (rb_printAll.Checked)
                    vDataIn = "All";
                else
                    if (rb_printCurr.Checked)
                        vDataIn = "Current";
                    else
                        if (rb_printExactly.Checked)
                            vDataIn = "Exactly";
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch(Exception){}

            try
            {
                string bsVerb = "Print.RangeText";
                object vDataIn = t_printExactly.Text;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Print.RangeReverse";
                object vDataIn;
                if (cb_printReverse.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Print.AsGrayscale";
                object vDataIn;
                if (cb_printGrayscale.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                object vDataIn;
                vDataIn = cob_DuplexMode.Text;
                axCoPDFXCview1.SetProperty("Print.Duplex", vDataIn, 0);
            }
            catch (Exception) { }

            try
            {
                axCoPDFXCview1.PrintDocument(nActiveDocID, (int)PXCVA_Flags.PXCVA_NoUI);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

        }

        private void b_PrintDlg_Click(object sender, EventArgs e)
        {
            if (g_nActiveDocID < 0)
                return;
            try
            {
                axCoPDFXCview1.PrintDocument(g_nActiveDocID, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void cb_EnableAllAccel_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                int cache;
                if (cb_ChacheChanges.Checked)
                    cache = (int)PXCVA_Flags.PXCVA_NoApply;
                    else
                        cache = 0;

                string bsVerb = "General.AllowAllAccelerators";
                object vDataIn;
                if (cb_EnableAllAccel.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void cb_DenyPopup_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                int cache;
                if (cb_ChacheChanges.Checked)
                    cache = (int)PXCVA_Flags.PXCVA_NoApply;
                else
                    cache = 0;

                string bsVerb = "General.DenyAllContextMenus";
                object vDataIn;
                if (cb_DenyContext.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void cb_DenyExport_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                int cache;
                if (cb_ChacheChanges.Checked)
                    cache = (int)PXCVA_Flags.PXCVA_NoApply;
                else
                    cache = 0;

                string bsVerb = "General.DenyAllExportOperations";
                object vDataIn;
                if (cb_DenyExport.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void btn_ShowExportDialog_Click(object sender, EventArgs e)
        {
            if (g_nActiveDocID < 0)
                return;
            try
            {
                axCoPDFXCview1.ExportDocument(g_nActiveDocID, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void b_exportBrowse_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK == folderBrowserDialog1.ShowDialog(this))
            {
                t_exportDestination.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void b_ApplyAndExport_Click(object sender, EventArgs e)
        {
            int nActiveDocID = g_nActiveDocID;
            if (nActiveDocID < 0)
                return;

            int cache;

            if (cb_ChacheChanges.Checked)
                cache = (int)PXCVA_Flags.PXCVA_NoApply;
            else
                cache = 0;

            try
            {
                string bsVerb = "Export.Image.RangeType";
                object vDataIn = "";
                if (rb_exportAll.Checked)
                    vDataIn = "All";
                else
                    if (rb_exportCurr.Checked)
                        vDataIn = "Current";
                    else
                        if (rb_exportExactly.Checked)
                            vDataIn = "Exactly";
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.Resolution";
                object vDataIn = cob_Resolution.Text;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.Type";
                object vDataIn = aImageTypeName[cob_ImageType.SelectedIndex];
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.Mode";
                object vDataIn = aExportModeName[cob_ExportMode.SelectedIndex];//cob_ExportMode.Text;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.Background";
                object vDataIn = "";
                try
                {
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataIn, 0);
                }
                finally
                {
                    if (cb_Transparent.Checked)
                        vDataIn = (uint)(vDataIn) & ~0xFF000000;
                    else
                        vDataIn = ((uint)vDataIn | 0xFF000000);
                    axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
                }
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.RangeReverse";
                object vDataIn;
                if (cb_exportReverse.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.RangeText";
                object vDataIn = t_exportExactly.Text;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.FolderName";
                object vDataIn = t_exportDestination.Text;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                string bsVerb = "Export.Image.FileName";
                object vDataIn = t_exportFileName.Text;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception) { }

            try
            {
                axCoPDFXCview1.ExportDocument(nActiveDocID, (int)PXCVA_Flags.PXCVA_NoUI);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void OnPropertyChangedLanguage(string pName)
        {
            bool bFullUpdate = StrCompare(pName, "FullUpdate");
            if (bFullUpdate || StrCompare(pName, "International.LocaleID"))
            {
                object vDataOut = 0;
                try
                {
                    string bsVerb = "International.LocaleID";
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, 0);
                }
                finally
                {
                    for (int i = 0; i <= aLangValue.Length-1; i++)
                        if (aLangValue[i] == (int)vDataOut)
                        {
                            cob_Language.SelectedIndex = i;
                            break;
                        }
                }
            }
        }

        private void cob_Language_SelectedIndexChanged(object sender, EventArgs e)
        {
            string str;
            object vDataIn;
            str = "International.LocaleID";
            vDataIn = aLangValue[cob_Language.SelectedIndex];
            try
            {
                axCoPDFXCview1.SetProperty(str, vDataIn, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void cb_DenyProgressDisplaying_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                int cache;
                if (cb_ChacheChanges.Checked)
                    cache = (int)PXCVA_Flags.PXCVA_NoApply;
                else
                    cache = 0;

                string bsVerb = "General.DenyProgressDisplaying";
                object vDataIn;
                if (cb_DenyProgressDisplaying.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;
                axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0 | cache);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void cb_Modified_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                int nActiveDocID = g_nActiveDocID;
                if (nActiveDocID < 0)
                    return;
                
                int cache;
                if (cb_ChacheChanges.Checked)
                    cache = (int)PXCVA_Flags.PXCVA_NoApply;
                else
                    cache = 0;

                string bsName = "Modified";
                object vDataIn;
                if (cb_Modified.Checked)
                    vDataIn = 1;
                else
                    vDataIn = 0;

                axCoPDFXCview1.SetDocumentProperty(nActiveDocID,bsName, vDataIn, 0 | cache);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void ReloadCommandsList()
        {
            listView1.Items.Clear();
	        int nCount = 0;
            bool bHideUnnamed = false;
            bHideUnnamed = cb_HideUnnamed.Checked;
            int DisplayedCount = 0;
	        {
                object vDataOut = 0;
                try
                {
                    string bsName = "Commands.Count";
                    axCoPDFXCview1.GetProperty(bsName, out vDataOut, 0);
                }
                catch (Exception)
                {
                    return;
                }
		        nCount = (int)vDataOut;
	        }
	        //
	        string str;
            string cmndName;
	        for (int i = 0; i < nCount; i++)
	        {
                ListViewItem lvItem;
                {
                    str = "Commands[" + i.ToString() + "].Name";
                    object vDataOut = 0;
                    try
                    {
                        axCoPDFXCview1.GetProperty(str, out vDataOut, 0);
                    }
                    catch (Exception)
                    {
                        break;
                    }
                    cmndName = vDataOut.ToString();
                    if (bHideUnnamed && cmndName == "")
                        continue;
                    DisplayedCount++;
                }
		        {
			        str = "Commands[" + i.ToString() + "].ID";
                    object vDataOut = 0;
                    try
                    {
                        axCoPDFXCview1.GetProperty(str, out vDataOut, 0);
                    }
                    catch (Exception)
                    {
                        break;
                    }
                    lvItem = new ListViewItem(vDataOut.ToString());
                }
                {
                    str = "Commands[" + i.ToString() + "].State";
                    object vDataOut = 0;
                    try
                    {
                        axCoPDFXCview1.GetProperty(str, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                    }
                    catch (Exception)
                    {
                        break;
                    }
                    lvItem.SubItems.Add(vDataOut.ToString());
                }
                {
                    lvItem.SubItems.Add(cmndName);
                }
                {
                    str = "Commands[" + i.ToString() + "].Title";
                    object vDataOut = 0;
                    try
                    {
                        axCoPDFXCview1.GetProperty(str, out vDataOut, 0);
                    }
                    catch (Exception)
                    {
                        break;
                    }
                    lvItem.SubItems.Add(vDataOut.ToString());
                }
                {
                    str = "Commands[" + i.ToString() + "].AdobeName";
                    object vDataOut = 0;
                    try
                    {
                        axCoPDFXCview1.GetProperty(str, out vDataOut, 0);
                    }
                    catch (Exception)
                    {
                        break;
                    }
                    lvItem.SubItems.Add(vDataOut.ToString());
                }
                listView1.Items.Add(lvItem);
            }
            lvwColumnSorter.SortColumn = 2;
            lvwColumnSorter.Order = SortOrder.Ascending;
            this.listView1.Sort();

            l_CommandsListC.Text = "Supported commands list (total " + nCount.ToString() + ", displayed " + DisplayedCount.ToString() + ")";
        }

        private void b_CommandsRefresh_Click(object sender, EventArgs e)
        {
            ReloadCommandsList();
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count != 0)
            {
                b_CommandExecute.Enabled = true;
                b_CommandTurnOnOff.Enabled = true;
                if (listView1.SelectedItems[0].SubItems[2].Text == "Find")
                {
                    lbl_FindText.Visible = true;
                    e_FindTextPrm.Visible = true;
                }
                else
                {
                    lbl_FindText.Visible = false;
                    e_FindTextPrm.Visible = false;
                }

            }
            else
            {
                b_CommandExecute.Enabled = false;
                b_CommandTurnOnOff.Enabled = false;
            }
            UpdateTurnButtonText();
        }

        void CommandExecute()
        {
            if (listView1.SelectedItems.Count == 0)
                return;
            ListViewItem lvItem;
            lvItem = listView1.SelectedItems[0];

            object vDataIn;

            if (lvItem.SubItems[2].Text == "Find")
            {
                object[] vArr = new object[2];
                object varg1 = Convert.ToInt32(lvItem.SubItems[0].Text);
                object varg2 = e_FindTextPrm.Text;
                vArr[0] = varg1;
                vArr[1] = varg2;
                vDataIn = vArr;
            }
            else
            {
                vDataIn = Convert.ToInt32(lvItem.SubItems[0].Text);
            }

            try
            {
                object vDataOut;
                axCoPDFXCview1.DoVerb(null, "ExecuteCommand", vDataIn, out vDataOut, 0);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void b_CommandExecute_Click(object sender, EventArgs e)
        {
            CommandExecute();
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            CommandExecute();
        }

        void UpdateTurnButtonText()
        {
            if (listView1.SelectedItems.Count == 0)
                return;
            ListViewItem lvItem;
            lvItem = listView1.SelectedItems[0];

            string str;
            str = lvItem.SubItems[1].Text;
            
            if (str == "Offline")
                b_CommandTurnOnOff.Text = "Turn On";
            else
                b_CommandTurnOnOff.Text = "Turn Off";
            
        }

        private void b_CommandTurnOnOff_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 0)
                return;
            ListViewItem lvItem;
            lvItem = listView1.SelectedItems[0];

            string bsState;
            bsState = lvItem.SubItems[1].Text;

            string bsName;
            bsName = lvItem.SubItems[2].Text;
            string cmndID;
            cmndID = lvItem.SubItems[0].Text;

            string bsVerb = "Commands[#" + cmndID + "].State";

            if (bsState != "Offline")
            {
                try
                {
                    object vDataIn = "Offline";
                    axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0);                    
                }
                catch (Exception ex)
                {
                    ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                }
            }
            else
            {
                try
                {
                    object vDataIn = "Online";
                    axCoPDFXCview1.SetProperty(bsVerb, vDataIn, 0);
                }
                catch (Exception ex)
                {
                    ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                }
            }

            {
                object vDataOut = 0;
                try
                {
                    axCoPDFXCview1.GetProperty(bsVerb, out vDataOut, (int)PXCVA_Flags.PXCVA_GetNamed);
                    lvItem.SubItems[1].Text = vDataOut.ToString();
                    UpdateTurnButtonText();
                }
                catch (Exception ex)
                {
                    ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                }                
            }
        }

        private void b_ioBrowse1_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "All Files (*.*)|*.*";
            if (DialogResult.OK == openFileDialog1.ShowDialog(this))
            {
                t_ioFileSrc.Text = openFileDialog1.FileName;
            }
            openFileDialog1.Filter = "PDF files (*.pdf)|*.pdf";
        }

        private void b_ioBrowse2_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "All Files (*.*)|*.*";
            if (DialogResult.OK == openFileDialog1.ShowDialog(this))
            {
                t_ioFileDst.Text = openFileDialog1.FileName;
            }
            openFileDialog1.Filter = "PDF files (*.pdf)|*.pdf";
        }

        private void b_IOLoad_Click(object sender, EventArgs e)
        {
            object vDataIn = "";
            if (rb_IORegistry.Checked)
            {
                vDataIn = t_ioRegSrc.Text;
            }
            else
            {
                vDataIn = t_ioFileSrc.Text;
            }
            try
            {
                axCoPDFXCview1.LoadSettings(vDataIn);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
            OnPropertyChanged("FullUpdate");
        }

        private void b_IOSave_Click(object sender, EventArgs e)
        {
            object vDataIn = "";
            if (rb_IORegistry.Checked)
            {
                vDataIn = t_ioRegDst.Text;
            }
            else
            {
                vDataIn = t_ioFileDst.Text;
            }
            try
            {
                axCoPDFXCview1.SaveSettings(ref vDataIn);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }

        private void rb_IORegistry_CheckedChanged(object sender, EventArgs e)
        {
            t_ioRegSrc.Enabled = rb_IORegistry.Checked;
            t_ioRegDst.Enabled = rb_IORegistry.Checked;
            t_ioFileSrc.Enabled = !rb_IORegistry.Checked;
            t_ioFileDst.Enabled = !rb_IORegistry.Checked;
            b_ioBrowse1.Enabled = !rb_IORegistry.Checked;
            b_ioBrowse2.Enabled = !rb_IORegistry.Checked;
        }

        private void b_openStream_Click(object sender, EventArgs e)
        {
            if (t_OpenDocFileName.Text == "")
            {
                MessageBox.Show("Please, specify the file name for open by IStream.");
                return;
            }
           
            int nFlags = 0;
            if (cb_OpenWithoutUI.Checked)
                nFlags = (int)PDFXCviewAxLib.PXCVA_Flags.PXCVA_NoUI;

            object vDataIn = "";
            object[] vArr = new object[2];

            FileStream readStream = new FileStream(t_OpenDocFileName.Text, FileMode.Open);

            {
                IStreamWrapper istr = new IStreamWrapper(readStream);
                object varg1 = istr;
                object varg2 = t_OpenDocPass.Text;
                vArr[0] = varg1;
                vArr[1] = varg2;
                vDataIn = vArr;
            }

            object OutPar;
            try
            {
                axCoPDFXCview1.DoVerb(null, "OpenDocument", vDataIn, out OutPar, nFlags);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

            readStream.Close();
            
        }

        private void b_saveStream_Click(object sender, EventArgs e)
        {
            string SaveTo = "";
            if (DialogResult.OK == saveFileDialog1.ShowDialog(this))
            {
                SaveTo = saveFileDialog1.FileName;
            }
            if (SaveTo == "")
                return;

            int nFlags = 0;
            if (cb_OpenWithoutUI.Checked)
                nFlags = (int)PDFXCviewAxLib.PXCVA_Flags.PXCVA_NoUI;

            object vDataIn = "";
            object[] vArr = new object[2];
            FileStream writeStream = new FileStream(SaveTo, FileMode.Create);

            IStreamWrapper istr = new IStreamWrapper(writeStream);
            object varg1 = g_nActiveDocID;
            object varg2 = istr;
            vArr[0] = varg1;
            vArr[1] = varg2;
            vDataIn = vArr;
            

            object OutPar;
            try
            {
                axCoPDFXCview1.DoVerb(null, "SaveDocument", vDataIn, out OutPar, nFlags);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }

            writeStream.Close();
        }

        private void cb_HideUnnamed_CheckedChanged(object sender, EventArgs e)
        {
            ReloadCommandsList();
        }

        private void listView_ItemChecked(object sender, ItemCheckedEventArgs e)
        {
            if (m_bSkipNotifications)
                return;
            object vDataOut, vDataIn;
            try
            {
                axCoPDFXCview1.GetActiveDocument(out g_nActiveDocID);
            }
            catch (Exception ex)
            {
                ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                return;
            }
            string sID = e.Item.SubItems[1].Text;
            string sVerb;
            if (e.Item.ListView == listView_View1)
            {
                sVerb = "View.";
            }
            else
            {
                sVerb = "Documents[#" + g_nActiveDocID.ToString() + "].View.";
            }
            sVerb += e.Item.SubItems[2].Text + "s[#" + sID + "].Visible";
            if (!TryGetProperty(sVerb, out vDataOut)) return;
            bool bFromVDataOut = ((int)vDataOut == 0) ? false : true;
            bool bCheckChanged = bFromVDataOut ^ e.Item.Checked;
            if (bCheckChanged)
            {
                vDataIn = e.Item.Checked ? 1 : 0;
                try
                {
                    axCoPDFXCview1.SetProperty(sVerb, vDataIn);
                }
                catch (Exception ex)
                {
                    ShowErrorMessage(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
                    return;
                }
            }
        }

        private void listView1_ColumnClick(object sender, ColumnClickEventArgs e)
        {
            // Determine if clicked column is already the column that is being sorted.
            if (e.Column == lvwColumnSorter.SortColumn)
            {
                // Reverse the current sort direction for this column.
                if (lvwColumnSorter.Order == SortOrder.Ascending)
                {
                    lvwColumnSorter.Order = SortOrder.Descending;
                }
                else
                {
                    lvwColumnSorter.Order = SortOrder.Ascending;
                }
            }
            else
            {
                // Set the column number that is to be sorted; default to ascending.
                lvwColumnSorter.SortColumn = e.Column;
                lvwColumnSorter.Order = SortOrder.Ascending;
            }

            // Perform the sort with these new sort options.
            this.listView1.Sort();
        }

        private void rb_printExactly_CheckedChanged(object sender, EventArgs e)
        {
            if (rb_printExactly.Checked) t_printExactly.Focus();
        }

        private void t_printExactly_Enter(object sender, EventArgs e)
        {
            rb_printExactly.Checked = true;
        }

        private void rb_exportExactly_CheckedChanged(object sender, EventArgs e)
        {
            if (rb_exportExactly.Checked) t_exportExactly.Focus();
        }

        private void t_exportExactly_Enter(object sender, EventArgs e)
        {
            rb_exportExactly.Checked = true;
        }


// START OF BUG CODE


		// Infragistics button and this will blow.
		private void ultraButton1_Click(object sender, EventArgs e)
		{
			Point contextMenuLocation = PointToScreen(ultraButton1.Location);
			contextMenuLocation.X += ultraButton1.Width + 20;

			ultraToolbarsManager1.Tools.Clear();

			PopupMenuTool popupTool = new PopupMenuTool("PopupMenu1");
			ButtonTool line1 = new ButtonTool("This is line 1");
			ButtonTool line2 = new ButtonTool("This is line 2");
			ButtonTool line3 = new ButtonTool("This is line 3");
			ButtonTool line4 = new ButtonTool("This is line 4");

			line1.SharedProps.Caption = "this menu";
			line2.SharedProps.Caption = "and button";
			line3.SharedProps.Caption = "is using";
			line4.SharedProps.Caption = "Infragistics 10.1";

			ultraToolbarsManager1.Tools.Add(popupTool);
			ultraToolbarsManager1.Tools.Add(line1);
			ultraToolbarsManager1.Tools.Add(line2);
			ultraToolbarsManager1.Tools.Add(line3);
			ultraToolbarsManager1.Tools.Add(line4);

			popupTool.Tools.Add(line1);
			popupTool.Tools.Add(line2);
			popupTool.Tools.Add(line3);
			popupTool.Tools.Add(line4);

			popupTool.AllowTearaway = false;
			popupTool.SharedProps.Caption = "Popup Menu 1";

			popupTool.ShowPopup(contextMenuLocation);
		}


		// Example of normal WINDOWS button
		private void button3_Click(object sender, EventArgs e)
		{
			Point contextMenuLocation = PointToScreen(button3.Location);
			contextMenuLocation.X += button3.Width + 20;
			ContextMenuStrip = new ContextMenuStrip();
			ContextMenuStrip.Items.Add("this menu");
			ContextMenuStrip.Items.Add("and button");
			ContextMenuStrip.Items.Add("is using ");
			ContextMenuStrip.Items.Add("windows");
			ContextMenuStrip.Show(contextMenuLocation);
		}
    }
}